<template>
	<div id="main" class="container clear-top text-light">
		<div>
			<h1 class="title pt-4 pb-3">Search</h1>
			<p>
				Contrary to popular belief, Lorem Ipsum is not simply random text. It has
				roots in a piece of classical Latin literature from 45 BC, making it over
				2000 years old. Richard McClintock, a Latin professor at Hampden-Sydney
				College in Virginia...
			</p>
			<SearchTaxon v-on:search-text="searchText" />
			<template v-if="loading">
				<div class="text-center pt-4">
					<span
						class="spinner-border spinner-border-sm"
						role="status"
						aria-hidden="true"
					></span>
					Loading...
				</div>
			</template>
			<template v-else-if="count">
				<div class="text-center pt-4">Results ({{ count }})</div>
			</template>
			<div class="row py-2">
				<TaxonResult
					v-for="taxon in taxons"
					:key="taxon.id"
					:id="taxon.id"
					:name="taxon.taxon"
					:rank="taxon.rank__rank_en"
					:author_year="taxon.author_year"
				/>
			</div>
		</div>
	</div>
</template>

<script>
import axios from "axios";
import Header from "../components/Header";
import TaxonResult from "../components/TaxonResult";
import SearchTaxon from "../components/SearchTaxon";

export default {
	head() {
		return {
			title: "Home | SARV Taxonomy Lookup",
			meta: [
				{
					hid: "description",
					name: "description",
					content:
						"Search for recorded taxonomies in the SARV geoscience data and collections database"
				}
			]
		};
	},
	components: {
		Header,
		TaxonResult,
		SearchTaxon
	},
	data() {
		return {
			count: "",
			taxons: [],
			loading: false
		};
	},

	methods: {
		async searchText(fields) {
			const baseURL =
				"https://api.geocollections.info/taxon/?fields=id,taxon,rank__rank_en,author_year";

			let query;
			let locationParams = "";
			let authorParam = "";
			let yearParams = "";
			let rankParam = "";

			// Define query parameters from the user input fields...

			//Location
			if (!fields.inEstonia)
				locationParams = locationParams.concat("&in_estonia=false");
			if (!fields.inBaltoscandia)
				locationParams = locationParams.concat("&in_baltoscandia=false");

			//Author year
			if (fields.authorYear)
				yearParams = yearParams.concat(
					`&author_year__iendswith=${fields.authorYear}`
				);

			//Parent author year
			if (fields.parentYear)
				yearParams = yearParams.concat(
					`&parent__author_year__iendswith=${fields.parentYear}`
				);

			//Author name
			if (fields.author.trim())
				authorParam = `&author_year__istartswith=${fields.author}`;

			//Rank
			if (fields.rank && fields.rankOption == "true") {
				rankParam = `&rank__rank_en__exact=${fields.rank}`;
			} else if (fields.rank && fields.rankOption == "false") {
				rankParam = `&rank__rank_en!=${fields.rank}`;
			}

			//Fill query with params
			fields.taxon
				? (query = `${baseURL}&taxon__${fields.option}=${fields.taxon}${locationParams}${authorParam}${yearParams}${rankParam}`)
				: (query = `${baseURL}${locationParams}${authorParam}${yearParams}${rankParam}`);

			//Send request, save results to state
			try {
				this.loading = true;
				const res = await axios.get(query);
				this.taxons = res.data.results;
				this.count = res.data.count ? res.data.count : "";
				console.log(res.data.results);
				console.log(query);
			} catch (err) {
				console.log(err);
			} finally {
				this.loading = false;
			}
		}
	}
};
</script>

<style>
.title {
	font-family: "Montserrat", sans-serif;
	display: block;
	font-weight: 400;
}

.subtitle {
	font-weight: 300;
	font-size: 42px;
	color: #526488;
	word-spacing: 5px;
	padding-bottom: 15px;
}

.links {
	padding-top: 15px;
}
</style>
